function [nlocvals,stop] = STEP()

global STEPalgo;

stop = 0;
nlocvals = 0;

newiter = 0;
if ((STEPalgo.ix == 0) || (STEPalgo.iter > STEPalgo.niterMax))   
    newiter = 1;    
end;

if (newiter == 1)
    STEPalgo.ix = STEPalgo.ix + 1;
    STEPalgo.iter = 1;
    STEPalgo.nt = 0;
    STEPalgo.t = zeros(1,1);
    STEPalgo.ft = zeros(1,1);
    STEPalgo.nt = STEPalgo.nt + 1;                              STEPalgo.t(STEPalgo.nt) = STEPalgo.x_a;   
    STEPalgo.sol(STEPalgo.ix) = STEPalgo.t(STEPalgo.nt);        STEPalgo.ft(STEPalgo.nt) = -feval(STEPalgo.myfunc,STEPalgo.sol); 
    STEPalgo.nt = STEPalgo.nt + 1;                              STEPalgo.t(STEPalgo.nt) = STEPalgo.x_b;  
    STEPalgo.sol(STEPalgo.ix) = STEPalgo.t(STEPalgo.nt);        STEPalgo.ft(STEPalgo.nt) = -feval(STEPalgo.myfunc,STEPalgo.sol);
    newiter = 0;
    nlocvals = 2;
    return;
end;

        ftarget = max(STEPalgo.ft);
        if (STEPalgo.iter == 1)
            i1 = 1;
            i2 = 2;
        else
            D = zeros(1,1);
            for k=1:STEPalgo.nt-1
                dx = STEPalgo.t(k+1) - STEPalgo.t(k);
                dy = STEPalgo.ft(k+1) - STEPalgo.ft(k);
                yhat = ftarget - STEPalgo.ft(k) + STEPalgo.feps;
                curD = (4*yhat - 2*dy + 4 * sqrt(yhat*yhat - yhat*dy))/(dx*dx);
                D(k) = curD;
            end;
            [Dmin indx] = sort(D);
            i1 = indx(1);
            i2 = indx(1)+1;
        end;
        STEPalgo.nt = STEPalgo.nt + 1;
        STEPalgo.t(STEPalgo.nt) = STEPalgo.t(i1) + 0.5*(STEPalgo.t(i2) - STEPalgo.t(i1));
        STEPalgo.sol(STEPalgo.ix) = STEPalgo.t(STEPalgo.nt);    
        STEPalgo.ft(STEPalgo.nt) = -feval(STEPalgo.myfunc,STEPalgo.sol); 
        [STEPalgo.t indxt] = sort(STEPalgo.t);
        STEPalgo.ft = STEPalgo.ft(indxt);
        if (rand() < 0.001)
            disp(['STEP ' num2str(STEPalgo.iter + 2) ' ' num2str(max(STEPalgo.ft))]);
        end;
        STEPalgo.iter = STEPalgo.iter + 1;
        if (STEPalgo.iter == STEPalgo.niterMax+1)
        	[fmax indmax] = max(STEPalgo.ft);
            STEPalgo.sol(STEPalgo.ix) = STEPalgo.t(indmax);
        end;
        nlocvals = 1;
        if ((STEPalgo.ix == STEPalgo.N) && (STEPalgo.iter == STEPalgo.niterMax+1))
            stop = 1;
        end;
return;
tic
for ix=1:N

    nt = 0;
    t = zeros(1,1);
    ft = zeros(1,1);
    nt = nt + 1;	t(nt) = a;   sol(ix) = t(nt);    ft(nt) = -feval(myfunc,sol); 
    nt = nt + 1;    t(nt) = b;   sol(ix) = t(nt);    ft(nt) = -feval(myfunc,sol);

    for iter=1:niterMax
        ftarget = max(ft);
        if (iter == 1)
            i1 = 1;
            i2 = 2;
        else
            D = zeros(1,1);
            for k=1:nt-1
                dx = t(k+1) - t(k);
                dy = ft(k+1) - ft(k);
                yhat = ftarget - ft(k) + feps;
                curD = (4*yhat - 2*dy + 4 * sqrt(yhat*yhat - yhat*dy))/(dx*dx);
                D(k) = curD;
            end;
            [Dmin indx] = sort(D);
            i1 = indx(1);
            i2 = indx(1)+1;
        end;
        nt = nt + 1;
        t(nt) = t(i1) + 0.5*(t(i2) - t(i1));
        sol(ix) = t(nt);    
        ft(nt) = -feval(myfunc,sol); 
        [t indxt] = sort(t);
        ft = ft(indxt);
        if (rand() < 0.1)
            disp([num2str(iter + 2) ' ' num2str(max(ft))]);
        end;
    end;
   [fmax indmax] = max(ft);
   sol(ix) = t(indmax);
end;

toc
zz = 0;

end
